package shadersmod.transform;

import static org.objectweb.asm.Opcodes.*;
import net.minecraft.launchwrapper.IClassTransformer;

import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Opcodes;

import shadersmod.common.SMCLog;

public class SMCCTVertexFormat implements IClassTransformer {

	@Override
	public byte[] transform(String par1, String par2, byte[] par3) {
		SMCLog.fine("transforming %s %s",par1,par2);
		ClassReader cr = new ClassReader(par3);
		ClassWriter cw = new ClassWriter(cr, 0);
		CVTransform cv = new CVTransform(cw);
		cr.accept(cv,0);
		return cw.toByteArray();
	}

	private static class CVTransform extends ClassVisitor
	{
		String classname;
		public CVTransform(ClassVisitor cv)
		{
			super(Opcodes.ASM4, cv);		
		}

		@Override
		public void visit(int version, int access, String name,
				String signature, String superName, String[] interfaces) {
			this.classname = name;
			//SMCLog.info(" class %s",name);
			super.visit(version, access, name, signature, superName, interfaces);
		}

		@Override
		public MethodVisitor visitMethod(int access, String name, String desc,
				String signature, String[] exceptions) 
		{
			if (Names.vertexFormat_init_vertexFormat.equalsNameDesc(name, desc))
			{
				SMCLog.finer("  patching method %s.%s%s",classname,name,desc);
				return new MVinitCopy(cv.visitMethod(access, name, desc, signature, exceptions));
			}
			//else
			//if (Names.vertexFormat_getVertexSize.equalsNameDesc(name, desc))
			//{
			//	SMCLog.finer("  patching method %s.%s%s",classname,name,desc);
			//	return new MVgetVertexSize(cv.visitMethod(access, name, desc, signature, exceptions));
			//}
			return cv.visitMethod(access, name, desc, signature, exceptions);
		}
		
	}

	private static class MVinitCopy extends MethodVisitor
	{
		public MVinitCopy(MethodVisitor mv) {
			super(Opcodes.ASM4, mv);
		}

		@Override
		public void visitMethodInsn(int opcode, String owner, String name, String desc) {
			if (Names.vertexFormat_getVertexSize.equals(owner,name,desc)) {
				mv.visitFieldInsn(GETFIELD, Names.vertexFormat_nextOffset.clasName, Names.vertexFormat_nextOffset.name, Names.vertexFormat_nextOffset.desc);
			} else {
				super.visitMethodInsn(opcode, owner, name, desc);
			}
		}

	}
	
	private static class MVgetVertexSize extends MethodVisitor
	{
		public MVgetVertexSize(MethodVisitor mv) {
			super(Opcodes.ASM4, mv);
		}

		@Override
		public void visitFieldInsn(int opcode, String owner, String name, String desc) {
			//if (opcode==GETFIELD && Names.vertexFormat_nextOffset.equals(owner, name, desc)) {
			//	mv.visitIntInsn(BIPUSH, 14*4);
			//} else {
				super.visitFieldInsn(opcode, owner, name, desc);
			//}
		}

	}

}
